//             (C) by Florian Lindner 1998
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <string.h>
#include <stdio.h>
#include <fcntl.h>
#include <io.h>
#include "Fmp3ID.h"
#include "ShortCuts.h"
#pragma resource "FComponents.res"
#pragma hdrstop
#pragma option -5 -O2 -OS -d- -fp -O -Oi -Ov -vi- -w-eas

__fastcall Fmp3ID::Fmp3ID(TComponent* Owner)
	: TComponent(Owner) {
}

namespace Fmp3id {
 void __fastcall Register() {
  TComponentClass classes[1] = {__classid(Fmp3ID)};
  RegisterComponents("FLoh!", classes, 0);
 }
}

void __fastcall Fmp3ID::SetFileName(AnsiString s) {
 FFileName = s;
 Actualize();
}

void Fmp3ID::Actualize() {
 GetFileSize();
 ReadData();
}

void Fmp3ID::GetFileSize() {
 if (FFileName != "") {
  hFile = open(FFileName.c_str(),O_RDONLY);
  FFileSize = filelength(hFile);
  close(hFile);
 }
}

void __fastcall Fmp3ID::SetFileSize(long) {
}

void __fastcall Fmp3ID::ReadData() {
 if (FFileName != "") {
  FILE *Fhandle;
  int handle;
  char title[30];
  char artist[30];
  char album[30];
  char year[4];
  char comment[30];
  AnsiString temp;
  Fhandle = fopen(FFileName.c_str(),"r");
  handle = open(FFileName.c_str(),O_RDONLY | O_BINARY);
  FFileSize = filelength(handle);
  fseek(Fhandle,FFileSize-125,0);
  fread(&title,30,1,Fhandle);
  fread(&artist,30,1,Fhandle);
  fread(&album,30,1,Fhandle);
  fread(&year,4,1,Fhandle);
  fread(&comment,30,1,Fhandle);
  fclose(Fhandle);
  close(handle);
  FArtist = artist;
  FArtist.SetLength(29);
  FTitle = title;
  FTitle.SetLength(29);
  FComment = comment;
  FComment.SetLength(29);
  FAlbum = album;
  FAlbum.SetLength(29);
  temp = year;
  temp.SetLength(4);
  FYear = temp.ToInt();
 }
}

AnsiString __fastcall Fmp3ID::GetArtist() {
 AnsiString ret;
 ReadData();
 ret = FArtist;
 return ret;
}

void __fastcall Fmp3ID::SetArtist(AnsiString) {
}

AnsiString __fastcall Fmp3ID::GetTitle() {
 AnsiString ret;
 ReadData();
 ret = FTitle;
 return ret;
}

void __fastcall Fmp3ID::SetTitle(AnsiString) {
}

AnsiString __fastcall Fmp3ID::GetComment() {
 AnsiString ret;
 ReadData();
 ret = FComment;
 return ret;
}

void __fastcall Fmp3ID::SetComment(AnsiString) {
}

int __fastcall Fmp3ID::GetYear() {
 int ret;
 ReadData();
 ret = FYear;
 return ret;
}

void __fastcall Fmp3ID::SetYear(int) {
}

AnsiString __fastcall Fmp3ID::GetAlbum() {
 AnsiString ret;
 ReadData();
 ret = FAlbum;
 return ret;
}

void __fastcall Fmp3ID::SetAlbum(AnsiString) {
}
